var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};

// packages/json-react-layouts/src/log.ts
import debug from "debug";
var jrlDebug = debug("json-react-layout");

// packages/json-react-layouts/src/middlewares.ts
var middlewareDebug = jrlDebug.extend("middleware");
function composeMiddleware(componentMiddlewares) {
  const pipeline = (props, middlewareProps, services, ...steps) => {
    const [step, ...next] = steps;
    middlewareDebug("Executing", { name: step.name, props, middlewareProps });
    return step ? step(props, middlewareProps, services, (stepProps, stepMiddlewareProps, stepServices) => pipeline(stepProps, stepMiddlewareProps, stepServices, ...next)) : null;
  };
  return (props, middlewareProps, services, next) => {
    return pipeline(props, middlewareProps, services, ...componentMiddlewares, (cp, mp, s) => {
      return next(cp, mp, s);
    });
  };
}

// packages/json-react-layouts/src/get-registration-creators.ts
function getRegistrationCreators() {
  return {
    createRegisterableComponent(type, render) {
      return { type, render };
    },
    createRegisterableComposition() {
      return (type, render, componentProps) => ({
        type,
        render,
        componentProps
      });
    }
  };
}

// packages/json-react-layouts/src/LayoutRegistration.tsx
import React4 from "react";

// packages/json-react-layouts/src/renderers/composition-renderer.tsx
import React2 from "react";

// packages/json-react-layouts/src/renderers/components-renderer.tsx
import React from "react";

// packages/json-react-layouts/src/renderers/component-renderer.tsx
var componentDebug = jrlDebug.extend("component");
var ComponentRenderer = ({
  type,
  componentRegistrations,
  componentProps,
  middlewareProps,
  componentMiddleware,
  services,
  layoutApi
}) => {
  const component = componentRegistrations.get(type);
  if (component === void 0) {
    return null;
  }
  const componentServices = {
    services,
    layout: layoutApi
  };
  const render = (middlewareComponentProps, _, services2) => {
    const props = middlewareComponentProps || componentProps;
    componentDebug("Rendering: %o", { type: component.type, props });
    const rendered = component.render(props, services2.services) || null;
    return rendered;
  };
  const middlewareRender = componentMiddleware(componentProps, middlewareProps, componentServices, render) || null;
  return middlewareRender;
};
ComponentRenderer.displayName = "ComponentRenderer";

// packages/json-react-layouts/src/renderers/components-renderer.tsx
var ComponentsRenderer = ({
  components,
  services,
  layoutApi,
  componentRegistrations,
  componentMiddleware,
  componentRenderPath,
  additionalComponentProps
}) => {
  return /* @__PURE__ */ React.createElement(React.Fragment, null, components.map((item, index) => {
    const _a = item, { type, props: componentProps } = _a, middlewareProps = __objRest(_a, ["type", "props"]);
    return /* @__PURE__ */ React.createElement(ComponentRenderer, {
      key: item.renderKey || index,
      type,
      layoutApi,
      componentRegistrations,
      componentProps: __spreadProps(__spreadValues(__spreadValues({}, additionalComponentProps), componentProps), {
        componentType: item.type,
        componentRenderPath: `${componentRenderPath}/[${index}]`
      }),
      middlewareProps,
      services,
      componentMiddleware
    });
  }));
};
ComponentsRenderer.displayName = "ComponentsRenderer";

// packages/json-react-layouts/src/renderers/composition-renderer.tsx
var compositionDebug = jrlDebug.extend("composition");
var CompositionRenderer = ({
  services,
  layoutApi,
  componentRenderPath,
  composition,
  compositionMiddleware,
  componentRegistrations,
  componentMiddleware,
  compositionRegistrations,
  additionalComponentProps
}) => {
  compositionDebug("Rendering: %o", {
    componentRenderPath,
    type: composition.type
  });
  const _a = composition, { contentAreas: contentAreas2, props: compositionProps } = _a, middlewareProps = __objRest(_a, ["contentAreas", "props"]);
  const componentServices = {
    services,
    layout: layoutApi
  };
  const compositionRegistration = compositionRegistrations.get(composition.type);
  if (!compositionRegistration) {
    return null;
  }
  function render(middlewareCompositionProps) {
    const compositionRenderProps = __spreadValues(__spreadValues({}, additionalComponentProps), middlewareCompositionProps || compositionProps);
    const contentAreas3 = Object.keys(composition.contentAreas).reduce((acc, contentAreaName) => {
      const componentsRenderPath = `${componentRenderPath}/${contentAreaName}`;
      compositionDebug("Rendering content area: %o", {
        componentsRenderPath,
        components: composition.contentAreas[contentAreaName].map((component) => ({
          type: component.type
        }))
      });
      const additionalProps = (compositionRegistration == null ? void 0 : compositionRegistration.componentProps) ? compositionRegistration == null ? void 0 : compositionRegistration.componentProps(contentAreaName, compositionRenderProps) : {};
      acc[contentAreaName] = /* @__PURE__ */ React2.createElement(ComponentsRenderer, {
        componentMiddleware,
        componentRegistrations,
        componentRenderPath: componentsRenderPath,
        components: composition.contentAreas[contentAreaName],
        layoutApi,
        services,
        additionalComponentProps: additionalProps
      });
      return acc;
    }, {});
    const rendered = compositionRegistration.render(contentAreas3, compositionRenderProps, services) || null;
    return rendered;
  }
  const middlewareRender = compositionMiddleware(composition.props, middlewareProps, componentServices, render) || null;
  return middlewareRender;
};
CompositionRenderer.displayName = "CompositionRenderer";

// packages/json-react-layouts/src/renderers/compositions-renderer.tsx
import React3 from "react";

// packages/json-react-layouts/src/helpers.ts
function getComponentPath(options) {
  const { subpath, index, prefix } = options;
  const componentPath = index !== void 0 ? `[${index}]${subpath}` : subpath;
  const prefixPath = prefix ? `${prefix}` : "";
  const renderPath = `${prefixPath}${componentPath}`;
  return renderPath;
}
function isNestedComposition(component) {
  return component.type === "nested-composition";
}
function flatMap(collection, map) {
  return collection.reduce((acc, val, i) => {
    map(val, i).forEach((v) => acc.push(v));
    return acc;
  }, []);
}
function getComponentsInCompositions(compositions, componentRenderPath) {
  return flatMap(compositions, (composition, i) => flatMap(Object.keys(composition.contentAreas), (key) => contentAreas(composition, i, key, componentRenderPath !== void 0, componentRenderPath)));
}
function expandNestedCompositionsIntoComponents(components, componentRenderPath) {
  const contentAreasArr = [];
  components.forEach((c, i) => {
    if (isNestedComposition(c)) {
      const props = c.props;
      const result = getComponentsInCompositions([props.composition], `${componentRenderPath}/[${i}]`);
      result.forEach((col) => contentAreasArr.push(col));
    } else {
      contentAreasArr.push(__spreadProps(__spreadValues({}, c), { componentRenderPath: `${componentRenderPath}/[${i}]` }));
    }
  });
  return contentAreasArr;
}
function contentAreas(composition, i, contentAreaKey, innerSearch, componentRenderPath) {
  const routeDataOptions = {
    subpath: !innerSearch ? composition.type : "nested:" + composition.type,
    index: !innerSearch ? i : void 0,
    prefix: componentRenderPath
  };
  const components = composition.contentAreas[contentAreaKey];
  const path = `${getComponentPath(routeDataOptions)}/${contentAreaKey}`;
  return expandNestedCompositionsIntoComponents(components, path);
}

// packages/json-react-layouts/src/renderers/compositions-renderer.tsx
var compositionDebug2 = jrlDebug.extend("compositions");
var CompositionsRenderer = ({
  services,
  renderPathPrefix,
  componentRegistrations,
  compositionRegistrations,
  componentMiddleware,
  compositionMiddleware,
  compositions,
  layoutApi
}) => {
  compositionDebug2("Rendering compositions: %o", {
    renderPathPrefix,
    compositions: compositions.map((composition) => ({
      type: composition.type
    }))
  });
  return /* @__PURE__ */ React3.createElement(React3.Fragment, null, compositions.map((composition, index) => {
    const componentRenderPath = getComponentPath({
      subpath: composition.type,
      index,
      prefix: renderPathPrefix
    });
    return /* @__PURE__ */ React3.createElement(CompositionRenderer, {
      key: composition.renderKey || index,
      componentRenderPath,
      componentRegistrations,
      compositionRegistrations,
      composition,
      layoutApi,
      services,
      componentMiddleware,
      compositionMiddleware,
      additionalComponentProps: {}
    });
  }));
};
CompositionsRenderer.displayName = "CompositionsRenderer";

// packages/json-react-layouts/src/LayoutRegistration.tsx
function LayoutRegistration() {
  return {
    registerComponents(registerCallback) {
      const registeredComponents = {};
      const componentMiddlewares = [];
      const builder = {
        registerComponent: (registration) => {
          if (registeredComponents[registration.type]) {
            throw new Error(`${registration.type} has already been registered`);
          }
          registeredComponents[registration.type] = registration;
          return builder;
        },
        registerMiddleware: (componentMiddleware) => {
          componentMiddlewares.push(componentMiddleware);
          return builder;
        }
      };
      registerCallback({
        registerComponent: (registration) => {
          if (registeredComponents[registration.type]) {
            throw new Error(`${registration.type} has already been registered`);
          }
          registeredComponents[registration.type] = registration;
          return builder;
        }
      });
      return {
        registerCompositions(registerCallback2) {
          const registeredCompositions = {};
          const compositionMiddlewares = [];
          const componentRegistrations = {
            isRegistered(type) {
              return registeredComponents[type] !== void 0;
            },
            get(type) {
              const foundComponent = registeredComponents[type];
              if (!foundComponent && process.env.NODE_ENV !== "production") {
                console.warn({ type }, `Component has not been registered`);
              }
              return foundComponent;
            }
          };
          const compositionRegistrations = {
            get(type) {
              const foundComposition = registeredCompositions[type];
              if (!foundComposition && process.env.NODE_ENV !== "production") {
                console.warn({ type }, `Composition has not been registered`);
              }
              return foundComposition;
            }
          };
          const { createRegisterableComponent } = getRegistrationCreators();
          const middlewares = {
            component: () => null,
            composition: () => null
          };
          const layout = {
            componentRegistrations,
            compositionRegistrations,
            component(component) {
              return component;
            },
            composition(composition) {
              return composition;
            },
            nestedComposition(composition) {
              return {
                type: "nested-composition",
                props: { composition }
              };
            },
            createRenderers({ services }) {
              return {
                renderComponents(...components) {
                  return /* @__PURE__ */ React4.createElement(ComponentsRenderer, {
                    layoutApi: layout,
                    componentMiddleware: middlewares.component,
                    componentRegistrations,
                    services,
                    components,
                    componentRenderPath: "",
                    additionalComponentProps: {}
                  });
                },
                renderCompositions(...compositions) {
                  return /* @__PURE__ */ React4.createElement(CompositionsRenderer, {
                    layoutApi: layout,
                    componentMiddleware: middlewares.component,
                    compositionMiddleware: middlewares.composition,
                    componentRegistrations,
                    compositionRegistrations,
                    services,
                    compositions
                  });
                }
              };
            }
          };
          builder.registerComponent(createRegisterableComponent("nested-composition", (_a, services) => {
            var _b = _a, {
              composition,
              componentRenderPath
            } = _b, additionalComponentProps = __objRest(_b, [
              "composition",
              "componentRenderPath"
            ]);
            if (composition.type === "nested-composition") {
              throw new Error("nested-composition is registered as a component, it is not allowed within a nested composition as it's not a composition, please check the route");
            }
            return /* @__PURE__ */ React4.createElement(CompositionRenderer, {
              composition,
              componentRenderPath: `${componentRenderPath}nested:${composition.type}`,
              services,
              layoutApi: layout,
              componentRegistrations,
              compositionRegistrations,
              componentMiddleware: middlewares.component,
              compositionMiddleware: middlewares.composition,
              additionalComponentProps
            });
          }));
          const compositionBuilder = {
            registerComposition(registration) {
              if (registeredCompositions[registration.type]) {
                throw new Error(`${registration.type} has already been registered`);
              }
              registeredCompositions[registration.type] = registration;
              return compositionBuilder;
            },
            registerMiddleware(compositionMiddleware) {
              compositionMiddlewares.push(compositionMiddleware);
              return compositionBuilder;
            }
          };
          registerCallback2(compositionBuilder);
          middlewares.component = composeMiddleware(componentMiddlewares);
          middlewares.composition = composeMiddleware(compositionMiddlewares);
          return layout;
        }
      };
    }
  };
}
export {
  LayoutRegistration,
  flatMap,
  getComponentsInCompositions,
  getRegistrationCreators,
  isNestedComposition
};
//# sourceMappingURL=index.js.map
