"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const __1 = require("..");
const testComponents_1 = require("./testComponents");
it('calculates correct render path', () => {
    const layout = __1.LayoutRegistration()
        .registerComponents(registrar => registrar
        .registerComponent(testComponents_1.testComponentRegistration)
        .registerComponent(testComponents_1.testComponent2Registration))
        .registerCompositions(registrar => registrar.registerComposition(testComponents_1.testCompositionRegistration));
    const compositions = [
        layout.composition({
            type: 'test-composition',
            props: {},
            contentAreas: {
                main: [
                    layout.component({ type: 'test', props: {} }),
                    layout.nestedComposition({
                        type: 'test-composition',
                        props: {},
                        contentAreas: {
                            main: [
                                layout.component({ type: 'test', props: {} }),
                                layout.component({ type: 'test', props: {} }),
                            ],
                        },
                    }),
                    layout.component({ type: 'test', props: {} }),
                ],
            },
        }),
    ];
    const components = __1.getComponentsInCompositions(compositions, undefined);
    expect(components).toEqual([
        {
            props: {},
            type: 'test',
            componentRenderPath: '[0]test-composition/main/[0]',
        },
        {
            props: {},
            type: 'test',
            componentRenderPath: '[0]test-composition/main/[1]nested:test-composition/main/[0]',
        },
        {
            props: {},
            type: 'test',
            componentRenderPath: '[0]test-composition/main/[1]nested:test-composition/main/[1]',
        },
        {
            props: {},
            type: 'test',
            componentRenderPath: '[0]test-composition/main/[2]',
        },
    ]);
});
//# sourceMappingURL=helpers.test.js.map